;------------------------------------------------------------------------------
; TINY ES40 EPROM-Bank
; (c) V. Pohlers 2021
;------------------------------------------------------------------------------
; Z9001 Zeichensatz, Rolf Weidlich ?
; wg. Kompatibilitt zur orig. ROM-Bank
; CALL %A4A -> CALL 37E0 laden Z9001-ZS
; CALL %0A4A  - einmal aufrufen und der Zeichensatz des Z1013 kann mit
; PROC SETR[%67,%10] ein- und mit PROC SETR[%67,%B0] ausgeschaltet werden. 
; Genutzt in JUMPER
;
; ES40c:
;0A4A   B0 54       CLR     %54
;0A4C   D6 09 2F    CALL    %092F
;0A4F   8D 37 E0    JP      %37E0
;------------------------------------------------------------------------------
;   %01...%1F original
;   %20...%7F original, aber schmal
;   %80...%FF Z9001 Blockgrafik  
;------------------------------------------------------------------------------

;AS-Funktionen
hi              function x,(x>>8)&255
lo              function x, x&255

	cpu	z8601

RP		EQU	0FDH		; Registerpointer

z_zs 	equ	0B000h	
	
	org 	37D0h

UMLADEN:
    LDE    R6,@RR0        ;Byte holen
    LDE    @RR2,R6        ;ablegen
    INCW    RR0            ;nchste EPROM-Adresse
    INCW    RR2            ;nchste RAM-Adresse
    DECW    RR4            ;Lnge-1
    JR    NZ,UMLADEN        ;wenn noch nicht 0
    RET

	org	037E0h

ZSW:    ;Umladen ZS nach B000
    PUSH    RP
    SRP    #70h
    LD    R0,#hi( Z9001)   ;Quelle im ROM
    LD    R1,#lo( Z9001)   ;
    LD    R2,#hi( Z_ZS)    ;Ziel im RAM
    LD    R3,#lo( Z_ZS)    ;
    LD    R4,#08h    ;Lnge
    LD    R5,#00h
    CALL    UMLADEN
    LD     67h,#hi( Z_ZS) ;neuen ZS einschalten
    POP    RP
    RET


	org	03800h
	
z9001:	binclude software/volker/zg_z9001.rom


	end	ZSW
		